package net.xinhuamm.xycloud.xinhuamm_xycloud;

import android.app.Dialog;
import android.graphics.drawable.GradientDrawable;
import android.view.Gravity;
import android.view.Window;
import android.view.WindowManager;

import androidx.annotation.NonNull;
import androidx.core.content.ContextCompat;
import androidx.fragment.app.DialogFragment;

/**
 * created by cmj on 2019-07-16
 * for:普通底部弹出窗基类
 */
public abstract class BaseBottomDialog extends BaseDialog {
    protected int animation;

    @Override
    protected void setDialogTheme() {
        setStyle(DialogFragment.STYLE_NO_TITLE, isLandscape ? getDialogLandscapeTheme() : getDialogTheme());
        animation = isLandscape ? R.style.Animation_Dialog_BaseRight : R.style.Animation_Dialog_BaseBottom;
    }

    protected int getDialogTheme() {
        return R.style.Theme_Dialog_BaseBottom;
    }

    protected int getDialogLandscapeTheme() {
        return R.style.Theme_Dialog_BaseBottom_Right;
    }

    @Override
    protected int getRootLayoutId() {
        return R.layout.xinhuamm_xycloud_layout_dialog_base_bottom;
    }

    @Override
    public void onResume() {
        super.onResume();
        rootView.postDelayed(new Runnable() {
            @Override
            public void run() {
                Dialog dialog = getDialog();
                if (null != dialog) {
                    Window window = dialog.getWindow();
                    if (null != window) {
                        window.setWindowAnimations(animation);
                    }
                }
            }
        }, 500);
    }

    @Override
    public void onStop() {
        super.onStop();
        Dialog dialog = getDialog();
        if (null != dialog) {
            Window window = dialog.getWindow();
            if (null != window) {
                window.setWindowAnimations(0);
            }
        }
    }

    @Override
    protected void onStartWindowConfig(@NonNull Window window) {
        WindowManager.LayoutParams params = window.getAttributes();
        params.dimAmount = getBackgroundAmount();
        if (isLandscape) {
            params.width = WindowManager.LayoutParams.WRAP_CONTENT;
            params.height = WindowManager.LayoutParams.MATCH_PARENT;
            params.gravity = Gravity.END;
        } else {
            params.width = WindowManager.LayoutParams.MATCH_PARENT;
            params.height = WindowManager.LayoutParams.WRAP_CONTENT;
            params.gravity = Gravity.BOTTOM;
        }
        window.setAttributes(params);
    }

    /**
     * 内容背景Drawable
     */
    @Override
    protected GradientDrawable getGradientDrawable() {
        GradientDrawable shape = new GradientDrawable();
        float corner10 = dpToPx(10.0f);
        shape.setCornerRadii(new float[]{corner10, corner10, corner10, corner10, 0, 0, 0, 0});
        shape.setColor(ContextCompat.getColor(context, getBackgroundColorRes()));
        return shape;
    }

}
