//
//  XYShareView.m
//  xinhuamm_xycloud
//
//  Created by 邓付磊 on 2024/1/6.
//

#import "XYShareView.h"
#import "XinhuammHelper.h"

@interface XYShareView()

@property (nonatomic, strong) UIView *containerView;

@property (nonatomic, strong) UIScrollView *scrollView;

@property (nonatomic, strong) UIView *lineView;


@property (nonatomic, strong) UIButton *cancelButton;

@end
@implementation XYShareView

- (instancetype)initWithFrame:(CGRect)frame {
    if (self = [super initWithFrame:frame]) {
        self.backgroundColor = [[UIColor blackColor] colorWithAlphaComponent:0.35];
        
        UIView *containerView = [[UIView alloc] initWithFrame:CGRectZero];
        _containerView = containerView;
        containerView.backgroundColor = [UIColor whiteColor];
        [self addSubview:containerView];
        UIScrollView *scrollView = [[UIScrollView alloc] initWithFrame:CGRectZero];
        scrollView.showsHorizontalScrollIndicator = NO;
        _scrollView = scrollView;
        [containerView addSubview:scrollView];
        
        NSArray *images = @[@{@"title":@"朋友圈",@"imageName":@"yx_weixin_friend_circle"},
                            @{@"title":@"微信好友",@"imageName":@"xy_weixin_friends"},
                            @{@"title":@"微博",@"imageName":@"xy_weibo_icon"},
                            @{@"title":@"QQ好友",@"imageName":@"xy_qq_icon"},
                            @{@"title":@"QQ空间",@"imageName":@"xy_qqzone_icon"}];
        UIButton *tmp = nil;
        for (NSInteger i = 0; i < images.count; i++) {
            NSString *title = [images[i] objectForKey:@"title"];
            NSString *imageName = [images[i] objectForKey:@"imageName"];
            UIButton *button = [UIButton buttonWithType:UIButtonTypeCustom];
            [button setImage:[XinhuammHelper imageNamed:imageName] forState:UIControlStateNormal];
            button.tag = 1000 + i;
            [button addTarget:self action:@selector(clickButtonAction:) forControlEvents:(UIControlEventTouchUpInside)];
            CGFloat x  = tmp ? CGRectGetMaxX(tmp.frame) : 0;
            CGFloat y = 0;
            CGFloat w = 70;
            if (images.count > 3 && images.count < 6) {
                w = [UIScreen mainScreen].bounds.size.width / images.count;
            }
            CGFloat h = 60;
            button.frame = CGRectMake(x, y, w, h);
            [scrollView addSubview:button];
            
            UILabel *lable = [[UILabel alloc] initWithFrame:CGRectZero];
            lable.text = title;
            lable.font = [UIFont systemFontOfSize:12];
            lable.textAlignment = NSTextAlignmentCenter;
            x = CGRectGetMinX(button.frame);
            y = CGRectGetMaxY(button.frame);
            w = CGRectGetWidth(button.frame);
            h = 20;
            lable.frame = CGRectMake(x, CGRectGetMaxY(button.frame), w, h);
            [scrollView addSubview:lable];
            tmp = button;
            
        }
        
        scrollView.contentSize = CGSizeMake(CGRectGetMaxX(tmp.frame), 0);
        
        _lineView = [[UIView alloc] initWithFrame:CGRectZero];
        _lineView.backgroundColor = [[UIColor blackColor] colorWithAlphaComponent:0.06];
        [containerView addSubview:_lineView];

        UIButton *cancelButton = [UIButton buttonWithType:UIButtonTypeCustom];
        [cancelButton setTitle:@"取消" forState:(UIControlStateNormal)];
        [cancelButton setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
        [cancelButton addTarget:self action:@selector(clickCancelButtonAction) forControlEvents:(UIControlEventTouchUpInside)];
        _cancelButton = cancelButton;
        [containerView addSubview:cancelButton];
    }
    return self;
}


- (void)layoutSubviews {
    
    CGFloat  x = 0;
    CGFloat  h = 90;
    CGFloat  w = CGRectGetWidth(self.frame);
    CGFloat  y = 10;
    self.scrollView.frame = CGRectMake(x, y, w, h);
    
    
    x = 0;
    w = CGRectGetWidth(self.frame);
    y = CGRectGetMaxY(self.scrollView.frame) + 1;
    h = 1;
    self.lineView.frame =  CGRectMake(x, y, w, h);
    
    x = 0;
    w = CGRectGetWidth(self.frame);
    y = CGRectGetMaxY(self.lineView.frame);
    h = 44;
    self.cancelButton.frame =  CGRectMake(x, y, w, h);

    x = 0;
    w = CGRectGetWidth(self.frame);
    h = CGRectGetMaxY(self.cancelButton.frame) + [[UIApplication sharedApplication].delegate window].safeAreaInsets.bottom;
    y = CGRectGetHeight(self.frame) - h;
    self.containerView.frame =  CGRectMake(x, y, w, h);
}


#pragma mark action
- (void)clickButtonAction:(UIButton *)button {
    NSInteger platform = button.tag - 1000;
    /// 0 -> @"朋友圈" ,1->@"微信好友",2->@"微博",3->@"QQ好友",4->@"QQ空间",5->@"钉钉"
    if (self.shareToPlatformBlock) {
        self.shareToPlatformBlock(platform);
    }
    [self clickCancelButtonAction];
    
}
- (void)clickCancelButtonAction {
    [UIView animateWithDuration:0.25 animations:^{
        self.alpha = 0;
    } completion:^(BOOL finished) {
        [self removeFromSuperview];
    }];
}
@end
